var nunjucks = require('nunjucks');
var fs = require('fs');
var dateFilter = require('nunjucks-date-filter');
var util = require('util');

var MyLoader = nunjucks.Loader.extend({
    fileSystemLoader: {},
    init: function(searchPaths, opts) {
        fileSystemLoader = new nunjucks.FileSystemLoader(searchPaths, opts);
    },

    getSource: function(name) {
        return fileSystemLoader.getSource(name+".html.nunjucks");
    }
});


module.exports = function() {
  var tr = this;
  var templates = {};
  tr.pre = function(cb) {
    var env = new nunjucks.Environment(new MyLoader('theme/templates',{watch: process.argv[2] !== "compileonly"}));
    env.addFilter('date', dateFilter);
    
    env.addFilter('paginationList', function(page, count) {
        var curPage = page;
        var pages = [];
        pages.push(curPage);
        for(var i = 0; i < count; i++) {
          curPage = curPage.metadata.prevpage;
          if(curPage === undefined) break;
          pages.unshift(curPage);
        }
        
        curPage = page;
        for(var i = 0; i < count; i++) {
          curPage = curPage.metadata.nextpage;
          if(curPage === undefined) break;
          pages.push(curPage);
        }
        return pages;
    });
    
    env.addFilter('inspect', function(obj) {
        return util.inspect(obj);
    });

    
    templates["article"] = env.getTemplate('article');
    templates["tag"] = env.getTemplate('tag');
    templates["redirect"] = env.getTemplate('redirect');
    cb();
  };

  tr.fancyname = "transformer nunjucks";

  tr.forEachPage = function(page, cb) {
    page.config = {
      baseurl: "",
      devel: process.argv[2] !== "compileonly"
    }
    var html = templates[page.type].render(page);
    //if(page.type == "tag") console.log(page.content[0].file);
    page.content = html;
    cb();
  }
}

